

# start in correct directory, we assume in example data repo
cd gapminder/files_unfiltered


# compute line numbers per file
wc -l Americas/*csv


wc -l Americas/*csv | head -n -1


wc -l Americas/*csv | head -n -1 | sort


wc -l Americas/*csv | head -n -1 | sort -n -r | head -20




#cd examples/gapminder   # or cd .. from above
cd ..
find files_unfiltered/Asia -size +2k -type f | xargs wc


cd files_unfiltered
find . -size +3k -type f -print0 | xargs --null wc


# max and min days query
find /opt/rstudio-drivers/ -mtime +31 -type d | wc -l

find /opt/ -mtime -14 -type d | wc -l


# hypothetical examples
# locate files 365 days or older matching *.backup
find dir -type f -ctime +365 -name \*.backup
#
find dir -type f -ctime +365 -name \*.backup | xargs --null tar cvfz /tmp/archive.tar.gz


# for loop
cd examples/gapminder
for c in files/*; do
    echo -n "${c} has "
    ls -1 ${c} | wc -l
done




for var in tic tac toc; do
    echo "Var is ${var}"
done


cd examples/gapminder/files
for var in A*; do
    echo "Var is ${var}"
done



length=$(wc -l some/file)
if [ ${length} -lt 10 ]; then
    echo "Small file"
else
    echo "Large file"
fi


# -- next snippets all corresponds to script1.sh

#!/bin/bash
currentDir=$(pwd)
echo "We are currently in directory ${currentDir}"
# <end snip


# -- and script2.sh

#!/bin/bash
set -eux
pwd
today=$(date +%Y%m%d)
echo "Today is ${todate}"  # typo
echo "Never reached"




# -- and script3.sh

#!/bin/bash
set -eu
cd ../files_unfiltered
for file in Europe/*.csv; do
    length=$(wc -l "${file}" | cut -f 1 -d " ")
    if [ ${length} -lt 20 ]; then
        echo "Small file ${file}"
    elif [ ${length} -lt 40 ]; then
        echo "Medium file ${file}"
    else
        echo "Large file ${file}"
    fi
done
