
## 'same as it ever was' from our examples directory
cat song.txt

sed -n 2,5p song.txt

sed -n /this/,/wife/p song.txt

sed -e s/may/will/g song.txt

sed -n -e 's/house/mansion/gp' -e 's/large/little/gp' song.txt



## prints first token (== `$1`) of each line
awk '{ print $1 }' song.txt

## prints first token of lines matching house
awk '/house/ { print $1 }' song.txt

## prints line(s) with more than 12 tokens (that are space-separated)
awk 'NF > 12' song.txt

## when first token matches 'And', print tokens $2 and $3
awk '$1 ~ /And/ { print $2,$3 }' song.txt

## variable and end block !
awk '/house/ { ++x }; END { print x }' song.txt




cd gapminder/files

## all
awk '{print $0}'  Oceania/Australia.csv

## split on ",", print only third col
awk -F, '{print $3}'  Oceania/Australia.csv

## combine with sed to not print 'year'
awk -F, '{print $3}'  Oceania/Australia.csv | sed -e1d -

## or
awk -F, '{print $3}'  Oceania/Australia.csv | sed -e/year/d -



## compute on the fly
awk '{ print $1, $2, $2 * $3 }' products.txt

awk '$3 > 0 { print $1, $2, $2 * $3; sum += $2 * $3 }; END { print "TOTAL:", sum }' products.txt




## diff and patch
diff -u textOne.txt textTwo.txt

## create patch file
diff -u textOne.txt textTwo.txt > one2two.patch

## make a copy
cp -vax textOne.txt textOne.txt.orig

## run a test ("dry-run")
patch --verbose --dry-run" < one2two.patch

## apply the patch (also try without verbose, make sure to copy the .orig in as needed)
patch --verbose  < one2two.patch
